<template lang="pug">
nav.pagination.mt-5( role="navigation" aria-label="pagination" )
	a.pagination-previous( :class='{ "is-disabled": disabledPrev }' @click='setPage(modelValue - 1)' )
		span.icon.is-medium
			i.fa-solid.fa-angle-left.fa-lg
	a.pagination-next( :class='{ "is-disabled": disabledPrev }' @click='setPage(modelValue + 1)' )
		span.icon.is-medium
			i.fa-solid.fa-angle-right.fa-lg
	ul.pagination-list
		template( v-if='modelValue >= 7' )
			pagination-item( :page='1' @click='setPage(1)' )
			li
				span.pagination-ellipsis &hellip;

		pagination-item(
			v-for='(page, i) in previousItems' :key='i'
			:page='page' @click='setPage(page)')
		pagination-item( :page='modelValue' current )
		pagination-item(
			v-for='(page, i) in nextItems' :key='i'
			:page='page' @click='setPage(page)')

		template( v-if='modelValue < total - 5 && total > 5' )
			li
				span.pagination-ellipsis &hellip;
			pagination-item( :page='total' @click='setPage(total)' )
</template>

<script setup>
import { computed } from "vue"

import PaginationItem from "./PaginationItem.vue"

const props = defineProps({
	modelValue: {
		type: [String, Number],
		default: 1
	},
	total: {
		type: [String, Number],
		default: 1
	}
})
const emit = defineEmits([ "update:modelValue" ])

const current = computed(() => props.modelValue)
const disabledPrev = computed(() => props.modelValue == 1)
const disabledNext = computed(() => props.modelValue == total)
const previousItems = computed(() => {
	let b = current.value - 3
	let data = []
	do {
		if (b > 0)
			data.push(b)
		b++
	} while (b < current.value)
	return data
})
const nextItems = computed(() => {
	let n = current.value + 1
	let data = []
	do {
		if (n <= props.total)
			data.push(n)
		n++
	} while (n < current.value + 4)
	return data
})

const setPage = to => {
	if (to < 1 || to > props.total) return

	emit("update:modelValue", to)
}
</script>

<style lang="scss" scoped>
.pagination-ellipsis {
	color: #000;
}
</style>